'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _class;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _wrapUpdate = require('../../util/wrapUpdate');

var _wrapUpdate2 = _interopRequireDefault(_wrapUpdate);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var FormGroup = (0, _wrapUpdate2.default)(_class = function (_Component) {
	_inherits(FormGroup, _Component);

	function FormGroup() {
		var _ref;

		var _temp, _this, _ret;

		_classCallCheck(this, FormGroup);

		for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
			args[_key] = arguments[_key];
		}

		return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = FormGroup.__proto__ || Object.getPrototypeOf(FormGroup)).call.apply(_ref, [this].concat(args))), _this), _this.getTitleBlock = function () {
			var _this$props = _this.props;
			var displayName = _this$props.displayName;
			var name = _this$props.name;
			var component = _this$props.component;


			switch (component) {
				case "Checkbox":
				case "Radio":
					return null;
			}

			if (displayName !== undefined && displayName !== null && displayName !== '') {
				return _react2.default.createElement(
					'h5',
					{ style: { margin: "0px" } },
					displayName
				);
			} else {
				return _react2.default.createElement(
					'h5',
					{ style: { margin: "0px" } },
					name
				);
			}
		}, _this.getHelpBlock = function () {
			var help = _this.props.help;


			if (help) {
				return _react2.default.createElement(
					'div',
					{ style: { color: "#757575" } },
					_react2.default.createElement(
						'b',
						null,
						help
					)
				);
			}

			return null;
		}, _this.getAddonBeforeBlock = function () {
			var addonBefore = _this.props.addonBefore;


			if (addonBefore) {
				return _react2.default.createElement(
					'div',
					{ className: 'col-md-3 pull-left', style: { textAlign: "left", marginTop: "15px", padding: "0px" } },
					_react2.default.createElement(
						'p',
						{ style: { margin: "0px" } },
						addonBefore
					)
				);
			}

			return null;
		}, _this.getAddonAfterBlock = function () {
			var addonAfter = _this.props.addonAfter;


			if (addonAfter) {
				return _react2.default.createElement(
					'div',
					{ className: 'col-md-3 pull-right', style: { textAlign: "right", marginTop: "15px", padding: "0px" } },
					_react2.default.createElement(
						'p',
						{ style: { margin: "0px" } },
						addonAfter
					)
				);
			}

			return null;
		}, _this.getChildrenBlock = function () {
			var _this$props2 = _this.props;
			var children = _this$props2.children;
			var addonAfter = _this$props2.addonAfter;
			var addonBefore = _this$props2.addonBefore;


			if (addonAfter || addonBefore) {
				return _react2.default.createElement(
					'div',
					{ className: 'col-md-9', style: { margin: "0px", padding: "0px" } },
					children
				);
			}

			return children;
		}, _temp), _possibleConstructorReturn(_this, _ret);
	}

	_createClass(FormGroup, [{
		key: 'render',
		value: function render() {
			return _react2.default.createElement(
				'div',
				{ style: { marginTop: "10px", marginBottom: "10px" } },
				_react2.default.createElement(
					'div',
					null,
					this.getTitleBlock()
				),
				_react2.default.createElement(
					'div',
					null,
					this.getAddonBeforeBlock(),
					this.getChildrenBlock(),
					this.getAddonAfterBlock()
				),
				this.getHelpBlock()
			);
		}
	}]);

	return FormGroup;
}(_react.Component)) || _class;

FormGroup.propTypes = {

	//Node props
	children: _react.PropTypes.node,

	//String props
	component: _react.PropTypes.string,
	displayName: _react.PropTypes.string,
	name: _react.PropTypes.string,
	help: _react.PropTypes.string,
	addonAfter: _react.PropTypes.string,
	addonBefore: _react.PropTypes.string
};

exports.default = FormGroup;
module.exports = exports['default'];