'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _class;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _materialUi = require('material-ui');

var _ArrayContainerItem = require('../common/ArrayContainerItem');

var _ArrayContainerItem2 = _interopRequireDefault(_ArrayContainerItem);

var _FormGroup = require('../common/FormGroup');

var _FormGroup2 = _interopRequireDefault(_FormGroup);

var _wrapUpdate = require('../../util/wrapUpdate');

var _wrapUpdate2 = _interopRequireDefault(_wrapUpdate);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var ArrayContainer = (0, _wrapUpdate2.default)(_class = function (_Component) {
    _inherits(ArrayContainer, _Component);

    function ArrayContainer() {
        var _ref;

        var _temp, _this, _ret;

        _classCallCheck(this, ArrayContainer);

        for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
            args[_key] = arguments[_key];
        }

        return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = ArrayContainer.__proto__ || Object.getPrototypeOf(ArrayContainer)).call.apply(_ref, [this].concat(args))), _this), _this.onClick = function () {
            var reduxFormProps = _this.props.reduxFormProps;

            reduxFormProps.addField({});
        }, _this.onAction = function (event, child, index) {
            var _this$props = _this.props;
            var id = _this$props.id;
            var value = _this$props.value;
            var fields = _this$props.fields;
            var onChange = _this$props.onChange;
            var _this$props$reduxForm = _this$props.reduxFormProps;
            var swapFields = _this$props$reduxForm.swapFields;
            var removeField = _this$props$reduxForm.removeField;

            var key = child.key;

            switch (key) {
                case "remove":
                    removeField(index);
                    break;
                case "move_up":
                    if (index > 0) {
                        swapFields(index, index - 1);
                    }
                    break;
                case "move_down":
                    if (index < fields.length - 1) {
                        swapFields(index, index + 1);
                    }
                    break;
                case "move_first":
                    swapFields(index, 0);
                    break;
                case "move_last":
                    swapFields(index, fields.length - 1);
                    break;
            }

            if (onChange) {
                var values = {
                    id: id,
                    value: value
                };

                onChange(values);
            }
        }, _this.buildGroupComponent = function (field) {
            var _this$props2 = _this.props;
            var componentFactory = _this$props2.componentFactory;
            var layout = _this$props2.layout;


            return componentFactory.buildGroupComponent({
                component: layout.component,
                layout: layout,
                fields: field,
                componentFactory: componentFactory
            });
        }, _this.getComponents = function () {
            var fields = _this.props.fields;


            return fields.map(function (field, index) {
                return _react2.default.createElement(
                    _ArrayContainerItem2.default,
                    { key: 'array-item-' + index + '-wrapper', index: index, onAction: _this.onAction },
                    _this.buildGroupComponent(field)
                );
            });
        }, _this.getAddBar = function () {
            var addText = _this.props.addText;


            var text = addText ? addText : "Add";
            var components = _this.getComponents();

            if (components.length) {
                return _react2.default.createElement(
                    _materialUi.Toolbar,
                    { className: 'add-bar' },
                    _react2.default.createElement(_materialUi.ToolbarGroup, { firstChild: true }),
                    _react2.default.createElement(
                        _materialUi.ToolbarGroup,
                        { lastChild: true },
                        _react2.default.createElement(_materialUi.RaisedButton, {
                            label: text,
                            onClick: _this.onClick,
                            primary: true
                        })
                    )
                );
            }

            return null;
        }, _this.getAllComponents = function () {
            var components = _this.getComponents();

            var toolbar = {
                border: "1px solid #616161",
                borderRadius: "2px",
                marginTop: "10px"
            };

            var title = {
                fontSize: "14px",
                marginLeft: "10px"
            };

            if (components.length) {
                return components;
            } else {
                return _react2.default.createElement(
                    _materialUi.Toolbar,
                    { style: toolbar },
                    _react2.default.createElement(
                        _materialUi.ToolbarGroup,
                        { firstChild: true },
                        _react2.default.createElement(_materialUi.ToolbarTitle, {
                            text: 'This array is empty',
                            style: title
                        })
                    ),
                    _react2.default.createElement(
                        _materialUi.ToolbarGroup,
                        null,
                        _react2.default.createElement(_materialUi.RaisedButton, {
                            label: 'Add new Item',
                            onClick: _this.onClick,
                            primary: true
                        })
                    )
                );
            }
        }, _temp), _possibleConstructorReturn(_this, _ret);
    }

    _createClass(ArrayContainer, [{
        key: 'render',
        value: function render() {
            var _props = this.props;
            var displayName = _props.displayName;
            var fieldLayout = _props.fieldLayout;
            var innerSize = _props.innerSize;
            var name = _props.name;
            var addonAfter = _props.addonAfter;
            var help = _props.help;
            var addonBefore = _props.addonBefore;

            var props = {
                displayName: displayName,
                name: name,
                fieldLayout: fieldLayout,
                innerSize: innerSize,
                addonAfter: addonAfter,
                addonBefore: addonBefore,
                help: help
            };

            return _react2.default.createElement(
                _FormGroup2.default,
                props,
                this.getAllComponents(),
                this.getAddBar()
            );
        }
    }]);

    return ArrayContainer;
}(_react.Component)) || _class;

ArrayContainer.propTypes = {

    //Number props
    innerSize: _react.PropTypes.number,

    //String props
    addonBefore: _react.PropTypes.string,
    addonAfter: _react.PropTypes.string,
    help: _react.PropTypes.string,
    component: _react.PropTypes.string,
    name: _react.PropTypes.string,
    addText: _react.PropTypes.string,
    type: _react.PropTypes.string,
    arrayType: _react.PropTypes.string,
    entityType: _react.PropTypes.string,
    layoutName: _react.PropTypes.string,
    displayName: _react.PropTypes.string,
    fieldLayout: _react.PropTypes.string,

    //Array props
    reduxFormProps: _react.PropTypes.array,
    fields: _react.PropTypes.array,

    //Object props
    layout: _react.PropTypes.object,
    componentFactory: _react.PropTypes.object,
    _extra: _react.PropTypes.object
};

exports.default = ArrayContainer;
module.exports = exports['default'];