'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _class;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reduxAutoformUtils = require('redux-autoform-utils');

var _FormGroup = require('../common/FormGroup');

var _FormGroup2 = _interopRequireDefault(_FormGroup);

var _materialUi = require('material-ui');

var _wrapUpdate = require('../../util/wrapUpdate');

var _wrapUpdate2 = _interopRequireDefault(_wrapUpdate);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var DateTimePicker = (0, _wrapUpdate2.default)(_class = function (_Component) {
	_inherits(DateTimePicker, _Component);

	function DateTimePicker() {
		var _ref;

		var _temp, _this, _ret;

		_classCallCheck(this, DateTimePicker);

		for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
			args[_key] = arguments[_key];
		}

		return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = DateTimePicker.__proto__ || Object.getPrototypeOf(DateTimePicker)).call.apply(_ref, [this].concat(args))), _this), _this.getFormat = function (format, type, formats) {
			if (!type) {
				throw Error('\'type\' should be truthy');
			}

			if (!formats) {
				throw Error('\'localizer\' should be truthy');
			}

			if (format) {
				return format;
			}

			switch (type) {
				case 'datetime':
					return formats.default;
				case 'date':
					return formats.date;
				case 'time':
					return formats.time;
				default:
					throw new Error('Invalid type. Type: ' + type);
			}
		}, _this.onChange = function (event, date) {
			var onChange = _this.props.onChange;

			onChange(date);
		}, _this.formatDate = function (date) {
			var _this$props = _this.props;
			var format = _this$props.format;
			var type = _this$props.type;

			var localizer = (0, _reduxAutoformUtils.getDateLocalizer)();

			format = _this.getFormat(format, type, localizer.formats);

			return localizer.format(date, format);
		}, _this.asDate = function (dateString) {
			var _this$props2 = _this.props;
			var format = _this$props2.format;
			var type = _this$props2.type;

			var localizer = (0, _reduxAutoformUtils.getDateLocalizer)();

			format = _this.getFormat(format, type, localizer.formats);

			return localizer.parse(dateString, format);
		}, _this.parseString = function () {
			var value = _this.props.value;


			if (typeof value === 'string') {
				return value === '' ? null : _this.asDate(value);
			} else {
				return value;
			}
		}, _temp), _possibleConstructorReturn(_this, _ret);
	}

	_createClass(DateTimePicker, [{
		key: 'render',
		value: function render() {
			var _props = this.props;
			var name = _props.name;
			var displayName = _props.displayName;
			var help = _props.help;
			var error = _props.error;
			var active = _props.active;
			var touched = _props.touched;
			var onBlur = _props.onBlur;
			var type = _props.type;
			var fieldLayout = _props.fieldLayout;
			var placeholder = _props.placeholder;
			var addonAfter = _props.addonAfter;
			var addonBefore = _props.addonBefore;

			var errors = touched || active ? error : null;

			var props = {
				displayName: displayName,
				name: name,
				help: help,
				addonAfter: addonAfter,
				addonBefore: addonBefore
			};

			switch (type) {
				case 'date':
					return _react2.default.createElement(
						_FormGroup2.default,
						props,
						_react2.default.createElement(_materialUi.DatePicker, {
							name: name,
							value: this.parseString(),
							mode: 'landscape',
							container: 'inline',
							errorText: errors,
							hintText: placeholder,
							onChange: this.onChange,
							formatDate: this.formatDate,
							onBlur: onBlur,
							type: type,
							fullWidth: true
						})
					);

				case 'time':
					return _react2.default.createElement(
						_FormGroup2.default,
						props,
						_react2.default.createElement(_materialUi.TimePicker, {
							format: '24hr',
							name: name,
							value: this.parseString(),
							errorText: errors,
							hintText: placeholder,
							onChange: this.onChange,
							onBlur: onBlur,
							type: type,
							fullWidth: true
						})
					);

				default:
					return false;
			}
		}
	}]);

	return DateTimePicker;
}(_react.Component)) || _class;

DateTimePicker.propTypes = {

	//Any props
	value: _react.PropTypes.any,

	//Bool props
	checked: _react.PropTypes.bool,
	valid: _react.PropTypes.bool,
	invalid: _react.PropTypes.bool,
	dirty: _react.PropTypes.bool,
	pristine: _react.PropTypes.bool,
	active: _react.PropTypes.bool,
	touched: _react.PropTypes.bool,
	visited: _react.PropTypes.bool,
	autofilled: _react.PropTypes.bool,
	required: _react.PropTypes.bool,

	//String props
	addonAfter: _react.PropTypes.string,
	addonBefore: _react.PropTypes.string,
	component: _react.PropTypes.string,
	placeholder: _react.PropTypes.string,
	name: _react.PropTypes.string,
	error: _react.PropTypes.string,
	type: _react.PropTypes.string,
	displayName: _react.PropTypes.string,
	initialValue: _react.PropTypes.string,
	fieldLayout: _react.PropTypes.string,
	format: _react.PropTypes.string,

	//Function props
	autofill: _react.PropTypes.func,
	onBlur: _react.PropTypes.func,
	onDragStart: _react.PropTypes.func,
	onDrop: _react.PropTypes.func,
	onFocus: _react.PropTypes.func,
	onUpdate: _react.PropTypes.func,
	onChange: _react.PropTypes.func,

	//Object props
	componentFactory: _react.PropTypes.object,
	reduxFormProps: _react.PropTypes.object,
	_extra: _react.PropTypes.object
};

exports.default = DateTimePicker;
module.exports = exports['default'];