'use strict';

Object.defineProperty(exports, "__esModule", {
				value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _class;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _FormGroup = require('../common/FormGroup');

var _FormGroup2 = _interopRequireDefault(_FormGroup);

var _wrapUpdate = require('../../util/wrapUpdate');

var _wrapUpdate2 = _interopRequireDefault(_wrapUpdate);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var FieldGroup = (0, _wrapUpdate2.default)(_class = function (_Component) {
				_inherits(FieldGroup, _Component);

				function FieldGroup() {
								var _ref;

								var _temp, _this, _ret;

								_classCallCheck(this, FieldGroup);

								for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
												args[_key] = arguments[_key];
								}

								return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = FieldGroup.__proto__ || Object.getPrototypeOf(FieldGroup)).call.apply(_ref, [this].concat(args))), _this), _this.getGroupContent = function () {
												var _this$props = _this.props;
												var componentFactory = _this$props.componentFactory;
												var _this$props$_extra = _this$props._extra;
												var layout = _this$props$_extra.layout;
												var fields = _this$props$_extra.fields;
												var groupName = _this$props.group;

												var group = layout.groups.find(function (g) {
																return g.name == groupName;
												});
												var groupProps = {
																component: group.component,
																layout: group,
																fields: fields,
																componentFactory: componentFactory
												};

												if (!group) {
																throw Error('Could not find group. Group: ' + groupName);
												}

												return componentFactory.buildGroupComponent(groupProps);
								}, _temp), _possibleConstructorReturn(_this, _ret);
				}

				_createClass(FieldGroup, [{
								key: 'render',
								value: function render() {
												var _props = this.props;
												var name = _props.name;
												var displayName = _props.displayName;
												var help = _props.help;
												var error = _props.error;
												var touched = _props.touched;
												var fieldLayout = _props.fieldLayout;
												var innerSize = _props.innerSize;
												var addonAfter = _props.addonAfter;
												var addonBefore = _props.addonBefore;

												var props = {
																displayName: displayName,
																name: name,
																help: help,
																addonAfter: addonAfter,
																addonBefore: addonBefore
												};

												return _react2.default.createElement(
																_FormGroup2.default,
																props,
																this.getGroupContent()
												);
								}
				}]);

				return FieldGroup;
}(_react.Component)) || _class;

FieldGroup.propTypes = {

				//Number props
				innerSize: _react.PropTypes.number,

				//Any props
				value: _react.PropTypes.any,
				options: _react.PropTypes.any,

				//Bool props
				checked: _react.PropTypes.bool,
				valid: _react.PropTypes.bool,
				invalid: _react.PropTypes.bool,
				dirty: _react.PropTypes.bool,
				pristine: _react.PropTypes.bool,
				active: _react.PropTypes.bool,
				touched: _react.PropTypes.bool,
				visited: _react.PropTypes.bool,
				autofilled: _react.PropTypes.bool,
				required: _react.PropTypes.bool,

				//String props
				group: _react.PropTypes.string,
				addonBefore: _react.PropTypes.string,
				addonAfter: _react.PropTypes.string,
				component: _react.PropTypes.string,
				help: _react.PropTypes.string,
				placeholder: _react.PropTypes.string,
				name: _react.PropTypes.string,
				error: _react.PropTypes.string,
				type: _react.PropTypes.string,
				displayName: _react.PropTypes.string,
				initialValue: _react.PropTypes.string,
				fieldLayout: _react.PropTypes.string,

				//Function props
				autofill: _react.PropTypes.func,
				onBlur: _react.PropTypes.func,
				onDragStart: _react.PropTypes.func,
				onDrop: _react.PropTypes.func,
				onFocus: _react.PropTypes.func,
				onUpdate: _react.PropTypes.func,
				onChange: _react.PropTypes.func,

				//Object props
				componentFactory: _react.PropTypes.object,
				reduxFormProps: _react.PropTypes.object,
				_extra: _react.PropTypes.object
};

exports.default = FieldGroup;
module.exports = exports['default'];