'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _class;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _materialUi = require('material-ui');

var _FetchUtils = require('../../util/FetchUtils');

var _FetchUtils2 = _interopRequireDefault(_FetchUtils);

var _wrapUpdate = require('../../util/wrapUpdate');

var _wrapUpdate2 = _interopRequireDefault(_wrapUpdate);

var _FormGroup = require('../common/FormGroup');

var _FormGroup2 = _interopRequireDefault(_FormGroup);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Lookup = (0, _wrapUpdate2.default)(_class = function (_Component) {
    _inherits(Lookup, _Component);

    function Lookup() {
        var _ref;

        var _temp, _this, _ret;

        _classCallCheck(this, Lookup);

        for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
            args[_key] = arguments[_key];
        }

        return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = Lookup.__proto__ || Object.getPrototypeOf(Lookup)).call.apply(_ref, [this].concat(args))), _this), _this.state = {
            dataSource: [],
            inputValue: ''
        }, _this.performNetworkSearch = function (url) {
            var inputValue = _this.state.inputValue;


            if (inputValue && inputValue !== '') {
                var searchUrl = url + inputValue;

                (0, _FetchUtils2.default)(searchUrl).then(function (response) {
                    return response.json();
                }).then(function (json) {
                    return _this.fillDataSourceFromRemote(json);
                }).catch(function (err) {
                    return _this.showErrorInConsole(err);
                });
            }
        }, _this.showErrorInConsole = function (err) {
            console.error('There was an when fetching resources. The error was => ' + err);
        }, _this.fillDataSource = function (arr) {
            var label = arguments.length <= 1 || arguments[1] === undefined ? 'label' : arguments[1];
            var value = arguments.length <= 2 || arguments[2] === undefined ? 'value' : arguments[2];

            var newDataSource = arr.map(function (item) {
                return {
                    text: item[label],
                    value: item[value]
                };
            });

            _this.setState({
                dataSource: newDataSource
            });
        }, _this.fillDataSourceFromLocal = function () {
            var options = _this.props.options;


            if (Array.isArray(options)) {
                _this.fillDataSource(options);
            }
        }, _this.fillDataSourceFromRemote = function (json) {
            var options = _this.props.options;
            var valueKey = options.valueKey;
            var labelKey = options.labelKey;
            var arrayKey = options.arrayKey;


            if (Array.isArray(json)) {
                _this.fillDataSource(json, labelKey, valueKey);
            } else {
                _this.fillDataSource(json[arrayKey], labelKey, valueKey);
            }
        }, _this.onUpdateInput = function (searchText) {
            var url = _this.props.options.url;

            var newState = {
                inputValue: searchText
            };

            if (url) {
                _this.setState(newState, function () {
                    return _this.performNetworkSearch(url);
                });
            } else {
                _this.setState(newState, function () {
                    return _this.fillDataSourceFromLocal();
                });
            }
        }, _this.onNewRequest = function (text) {
            var onChange = _this.props.onChange;


            onChange(text);
        }, _temp), _possibleConstructorReturn(_this, _ret);
    }

    _createClass(Lookup, [{
        key: 'componentWillMount',
        value: function componentWillMount() {
            this.fillDataSourceFromLocal();
        }
    }, {
        key: 'componentWillUnmount',
        value: function componentWillUnmount() {
            //Reset state when this component is unmounted
            this.setState({
                dataSource: [],
                inputValue: ''
            });
        }
    }, {
        key: 'render',
        value: function render() {
            var _props = this.props;
            var displayName = _props.displayName;
            var name = _props.name;
            var addonAfter = _props.addonAfter;
            var addonBefore = _props.addonBefore;
            var placeholder = _props.placeholder;
            var error = _props.error;
            var touched = _props.touched;
            var active = _props.active;
            var help = _props.help;
            var onBlur = _props.onBlur;

            var errors = touched || active ? error : null;
            var dataSource = this.state.dataSource;


            var props = {
                displayName: displayName,
                name: name,
                help: help,
                addonAfter: addonAfter,
                addonBefore: addonBefore
            };

            return _react2.default.createElement(
                _FormGroup2.default,
                props,
                _react2.default.createElement(_materialUi.AutoComplete, {
                    filter: _materialUi.AutoComplete.caseInsensitiveFilter,
                    errorText: errors,
                    dataSource: dataSource,
                    hintText: placeholder,
                    onNewRequest: this.onNewRequest,
                    onUpdateInput: this.onUpdateInput,
                    onBlur: onBlur,
                    fullWidth: true,
                    animated: true,
                    openOnFocus: true
                })
            );
        }
    }]);

    return Lookup;
}(_react.Component)) || _class;

Lookup.propTypes = {

    //Number props
    innerSize: _react.PropTypes.number,

    //Any props
    value: _react.PropTypes.any,
    options: _react.PropTypes.any,

    //Bool props
    checked: _react.PropTypes.bool,
    valid: _react.PropTypes.bool,
    invalid: _react.PropTypes.bool,
    dirty: _react.PropTypes.bool,
    pristine: _react.PropTypes.bool,
    active: _react.PropTypes.bool,
    touched: _react.PropTypes.bool,
    visited: _react.PropTypes.bool,
    autofilled: _react.PropTypes.bool,
    required: _react.PropTypes.bool,

    //String props
    addonAfter: _react.PropTypes.string,
    addonBefore: _react.PropTypes.string,
    component: _react.PropTypes.string,
    help: _react.PropTypes.string,
    placeholder: _react.PropTypes.string,
    name: _react.PropTypes.string,
    error: _react.PropTypes.string,
    type: _react.PropTypes.string,
    displayName: _react.PropTypes.string,
    initialValue: _react.PropTypes.string,
    fieldLayout: _react.PropTypes.string,

    //Function props
    autofill: _react.PropTypes.func,
    onBlur: _react.PropTypes.func,
    onDragStart: _react.PropTypes.func,
    onDrop: _react.PropTypes.func,
    onFocus: _react.PropTypes.func,
    onUpdate: _react.PropTypes.func,
    onChange: _react.PropTypes.func,

    //Object props
    componentFactory: _react.PropTypes.object,
    reduxFormProps: _react.PropTypes.object,
    _extra: _react.PropTypes.object
};

exports.default = Lookup;
module.exports = exports['default'];