'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _class;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _materialUi = require('material-ui');

var _FormGroup = require('../common/FormGroup');

var _FormGroup2 = _interopRequireDefault(_FormGroup);

var _wrapUpdate = require('../../util/wrapUpdate');

var _wrapUpdate2 = _interopRequireDefault(_wrapUpdate);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Number = (0, _wrapUpdate2.default)(_class = function (_Component) {
    _inherits(Number, _Component);

    function Number() {
        _classCallCheck(this, Number);

        return _possibleConstructorReturn(this, (Number.__proto__ || Object.getPrototypeOf(Number)).apply(this, arguments));
    }

    _createClass(Number, [{
        key: 'render',
        value: function render() {
            var _props = this.props;
            var value = _props.value;
            var error = _props.error;
            var addonAfter = _props.addonAfter;
            var addonBefore = _props.addonBefore;
            var displayName = _props.displayName;
            var help = _props.help;
            var name = _props.name;
            var onChange = _props.onChange;
            var placeholder = _props.placeholder;
            var min = _props.min;
            var max = _props.max;
            var touched = _props.touched;
            var active = _props.active;
            var onBlur = _props.onBlur;

            var errors = touched || active ? error : null;
            var intValue = value ? value : min;

            var props = {
                displayName: displayName,
                name: name,
                help: help,
                addonAfter: addonAfter,
                addonBefore: addonBefore
            };

            return _react2.default.createElement(
                _FormGroup2.default,
                props,
                _react2.default.createElement(_materialUi.TextField, {
                    name: name,
                    value: intValue,
                    errorText: errors,
                    hintText: placeholder,
                    type: 'number',
                    min: parseInt(min),
                    max: parseInt(max),
                    onChange: onChange,
                    onBlur: onBlur,
                    fullWidth: true
                })
            );
        }
    }]);

    return Number;
}(_react.Component)) || _class;

Number.propTypes = {

    //Number props
    min: _react.PropTypes.number,
    max: _react.PropTypes.number,

    //Any props
    value: _react.PropTypes.any,

    //Bool props
    checked: _react.PropTypes.bool,
    valid: _react.PropTypes.bool,
    invalid: _react.PropTypes.bool,
    dirty: _react.PropTypes.bool,
    pristine: _react.PropTypes.bool,
    active: _react.PropTypes.bool,
    touched: _react.PropTypes.bool,
    visited: _react.PropTypes.bool,
    autofilled: _react.PropTypes.bool,
    required: _react.PropTypes.bool,

    //String props
    addonAfter: _react.PropTypes.string,
    addonBefore: _react.PropTypes.string,
    component: _react.PropTypes.string,
    placeholder: _react.PropTypes.string,
    name: _react.PropTypes.string,
    error: _react.PropTypes.string,
    type: _react.PropTypes.string,
    displayName: _react.PropTypes.string,
    initialValue: _react.PropTypes.string,
    fieldLayout: _react.PropTypes.string,

    //Function props
    autofill: _react.PropTypes.func,
    onBlur: _react.PropTypes.func,
    onDragStart: _react.PropTypes.func,
    onDrop: _react.PropTypes.func,
    onFocus: _react.PropTypes.func,
    onUpdate: _react.PropTypes.func,
    onChange: _react.PropTypes.func,

    //Object props
    componentFactory: _react.PropTypes.object,
    reduxFormProps: _react.PropTypes.object,
    _extra: _react.PropTypes.object
};

exports.default = Number;
module.exports = exports['default'];