'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _class;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _materialUi = require('material-ui');

var _FormGroup = require('../common/FormGroup');

var _FormGroup2 = _interopRequireDefault(_FormGroup);

var _wrapUpdate = require('../../util/wrapUpdate');

var _wrapUpdate2 = _interopRequireDefault(_wrapUpdate);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Radio = (0, _wrapUpdate2.default)(_class = function (_Component) {
    _inherits(Radio, _Component);

    function Radio() {
        var _ref;

        var _temp, _this, _ret;

        _classCallCheck(this, Radio);

        for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
            args[_key] = arguments[_key];
        }

        return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = Radio.__proto__ || Object.getPrototypeOf(Radio)).call.apply(_ref, [this].concat(args))), _this), _this.onChange = function (event, value) {
            var onChange = _this.props.onChange;

            onChange(value);
        }, _this.getOptions = function () {
            var _this$props = _this.props;
            var options = _this$props.options;
            var name = _this$props.name;
            var fieldLayout = _this$props.fieldLayout;

            // // these props don't vary per item
            // let invariantRadioProps = { inline: fieldLayout == 'inline', name, onChange: this.onChange };

            return options.map(function (_ref2, index) {
                var text = _ref2.text;
                var value = _ref2.value;
                return _react2.default.createElement(_materialUi.RadioButton, { key: index, label: text, value: value });
            });
        }, _temp), _possibleConstructorReturn(_this, _ret);
    }

    _createClass(Radio, [{
        key: 'render',
        value: function render() {
            var _props = this.props;
            var error = _props.error;
            var touched = _props.touched;
            var displayName = _props.displayName;
            var name = _props.name;
            var help = _props.help;
            var fieldLayout = _props.fieldLayout;
            var innerSize = _props.innerSize;
            var value = _props.value;
            var onBlur = _props.onBlur;
            var addonAfter = _props.addonAfter;
            var addonBefore = _props.addonBefore;
            var component = _props.component;

            var props = {
                displayName: displayName,
                name: name,
                help: help,
                addonAfter: addonAfter,
                addonBefore: addonBefore,
                component: component
            };

            return _react2.default.createElement(
                _FormGroup2.default,
                props,
                _react2.default.createElement(
                    _materialUi.RadioButtonGroup,
                    {
                        name: name,
                        valueSelected: value,
                        onChange: this.onChange,
                        onBlur: onBlur
                    },
                    this.getOptions()
                )
            );
        }
    }]);

    return Radio;
}(_react.Component)) || _class;

Radio.propTypes = {

    //Any props
    value: _react.PropTypes.any,

    //Bool props
    checked: _react.PropTypes.bool,
    valid: _react.PropTypes.bool,
    invalid: _react.PropTypes.bool,
    dirty: _react.PropTypes.bool,
    pristine: _react.PropTypes.bool,
    active: _react.PropTypes.bool,
    touched: _react.PropTypes.bool,
    visited: _react.PropTypes.bool,
    autofilled: _react.PropTypes.bool,
    required: _react.PropTypes.bool,

    //String props
    help: _react.PropTypes.string,
    addonAfter: _react.PropTypes.string,
    addonBefore: _react.PropTypes.string,
    component: _react.PropTypes.string,
    placeholder: _react.PropTypes.string,
    name: _react.PropTypes.string,
    error: _react.PropTypes.string,
    type: _react.PropTypes.string,
    displayName: _react.PropTypes.string,
    initialValue: _react.PropTypes.string,
    fieldLayout: _react.PropTypes.string,

    //Function props
    autofill: _react.PropTypes.func,
    onBlur: _react.PropTypes.func,
    onDragStart: _react.PropTypes.func,
    onDrop: _react.PropTypes.func,
    onFocus: _react.PropTypes.func,
    onUpdate: _react.PropTypes.func,
    onChange: _react.PropTypes.func,

    //Object props
    componentFactory: _react.PropTypes.object,
    reduxFormProps: _react.PropTypes.object,
    _extra: _react.PropTypes.object
};

exports.default = Radio;
module.exports = exports['default'];