'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _class;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _materialUi = require('material-ui');

var _FetchUtils = require('../../util/FetchUtils');

var _FetchUtils2 = _interopRequireDefault(_FetchUtils);

var _wrapUpdate = require('../../util/wrapUpdate');

var _wrapUpdate2 = _interopRequireDefault(_wrapUpdate);

var _FormGroup = require('../common/FormGroup');

var _FormGroup2 = _interopRequireDefault(_FormGroup);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Select = (0, _wrapUpdate2.default)(_class = function (_Component) {
    _inherits(Select, _Component);

    function Select() {
        var _ref;

        var _temp, _this, _ret;

        _classCallCheck(this, Select);

        for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
            args[_key] = arguments[_key];
        }

        return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = Select.__proto__ || Object.getPrototypeOf(Select)).call.apply(_ref, [this].concat(args))), _this), _this.state = {
            value: {},
            urlOptions: [],
            urlErrors: null
        }, _this.onChange = function (event, index, value) {
            var onChange = _this.props.onChange;


            onChange(value);
            _this.setState({ value: value });
        }, _this.getItems = function () {
            var options = _this.props.options;
            var url = options.url;
            var labelKey = options.labelKey;
            var valueKey = options.valueKey;
            var _this$state = _this.state;
            var urlOptions = _this$state.urlOptions;
            var urlErrors = _this$state.urlErrors;


            if (Array.isArray(options)) {
                return _this.renderItems(options);
            } else if (url && labelKey && valueKey) {
                if (Array.isArray(urlOptions)) {
                    return _this.renderItems(urlOptions, valueKey, labelKey);
                } else if (urlErrors) {
                    console.error('Select - There was the following error when fetching from resource =>\n                    ' + JSON.stringify(urlErrors, null, 2));
                }
            }
        }, _this.renderItems = function (arr) {
            var value = arguments.length <= 1 || arguments[1] === undefined ? 'value' : arguments[1];
            var text = arguments.length <= 2 || arguments[2] === undefined ? 'text' : arguments[2];

            return arr.map(function (item, index) {
                return _react2.default.createElement(_materialUi.MenuItem, {
                    key: 'select-item-' + index + '-wrapper',
                    value: item[value],
                    primaryText: item[text]
                });
            });
        }, _temp), _possibleConstructorReturn(_this, _ret);
    }

    //TODO evaluate if options.url come and array comes too


    _createClass(Select, [{
        key: 'componentWillMount',
        value: function componentWillMount() {
            var _this2 = this;

            var options = this.props.options;
            var url = options.url;


            if (url) {
                (0, _FetchUtils2.default)(url).then(function (response) {
                    return response.json();
                }).then(function (response) {
                    return _this2.setState({ urlOptions: response });
                });
            }
        }
    }, {
        key: 'render',
        value: function render() {
            var _props = this.props;
            var addonBefore = _props.addonBefore;
            var addonAfter = _props.addonAfter;
            var displayName = _props.displayName;
            var name = _props.name;
            var placeholder = _props.placeholder;
            var error = _props.error;
            var touched = _props.touched;
            var active = _props.active;
            var help = _props.help;
            var onBlur = _props.onBlur;

            var errors = touched || active ? error : null;
            var value = this.state.value;


            var props = {
                displayName: displayName,
                name: name,
                help: help,
                addonBefore: addonBefore,
                addonAfter: addonAfter
            };

            return _react2.default.createElement(
                _FormGroup2.default,
                props,
                _react2.default.createElement(
                    _materialUi.SelectField,
                    {
                        errorText: errors,
                        value: value,
                        hintText: placeholder,
                        onChange: this.onChange,
                        onBlur: onBlur,
                        fullWidth: true
                    },
                    this.getItems()
                )
            );
        }
    }]);

    return Select;
}(_react.Component)) || _class;

Select.propTypes = {

    //Number props
    innerSize: _react.PropTypes.number,

    //Any props
    value: _react.PropTypes.any,
    options: _react.PropTypes.any,

    //Bool props
    checked: _react.PropTypes.bool,
    valid: _react.PropTypes.bool,
    invalid: _react.PropTypes.bool,
    dirty: _react.PropTypes.bool,
    pristine: _react.PropTypes.bool,
    active: _react.PropTypes.bool,
    touched: _react.PropTypes.bool,
    visited: _react.PropTypes.bool,
    autofilled: _react.PropTypes.bool,
    required: _react.PropTypes.bool,

    //String props
    addonAfter: _react.PropTypes.string,
    addonBefore: _react.PropTypes.string,
    component: _react.PropTypes.string,
    help: _react.PropTypes.string,
    placeholder: _react.PropTypes.string,
    name: _react.PropTypes.string,
    error: _react.PropTypes.string,
    type: _react.PropTypes.string,
    displayName: _react.PropTypes.string,
    initialValue: _react.PropTypes.string,
    fieldLayout: _react.PropTypes.string,

    //Function props
    autofill: _react.PropTypes.func,
    onBlur: _react.PropTypes.func,
    onDragStart: _react.PropTypes.func,
    onDrop: _react.PropTypes.func,
    onFocus: _react.PropTypes.func,
    onUpdate: _react.PropTypes.func,
    onChange: _react.PropTypes.func,

    //Object props
    componentFactory: _react.PropTypes.object,
    reduxFormProps: _react.PropTypes.object,
    _extra: _react.PropTypes.object
};

exports.default = Select;
module.exports = exports['default'];