'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _class;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _BaseGroup2 = require('./BaseGroup');

var _BaseGroup3 = _interopRequireDefault(_BaseGroup2);

var _materialUi = require('material-ui');

var _Arrays = require('../../util/Arrays');

var _Arrays2 = _interopRequireDefault(_Arrays);

var _wrapUpdate = require('../../util/wrapUpdate');

var _wrapUpdate2 = _interopRequireDefault(_wrapUpdate);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var QuestionnaireGroup = (0, _wrapUpdate2.default)(_class = function (_BaseGroup) {
    _inherits(QuestionnaireGroup, _BaseGroup);

    function QuestionnaireGroup() {
        var _ref;

        var _temp, _this, _ret;

        _classCallCheck(this, QuestionnaireGroup);

        for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
            args[_key] = arguments[_key];
        }

        return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = QuestionnaireGroup.__proto__ || Object.getPrototypeOf(QuestionnaireGroup)).call.apply(_ref, [this].concat(args))), _this), _this.state = {
            size: _this.props.fields.length,
            percentage: 0
        }, _this.filterValues = function (fields) {
            var arr = _Arrays2.default.mergeJson(fields.map(function (field) {
                var _field$reduxFormProps = field.reduxFormProps;
                var value = _field$reduxFormProps.value;
                var touched = _field$reduxFormProps.touched;
                var name = _field$reduxFormProps.name;


                if (touched) {
                    return value && !(value === '') ? _defineProperty({}, name, value) : null;
                }

                return null;
            }));

            return Object.keys(arr);
        }, _this.calculatePercentage = function (fields) {
            var size = _this.state.size;


            var filteredValues = _this.filterValues(fields);
            var completedFields = filteredValues.length;

            _this.setState({
                percentage: completedFields * 100 / size
            });
        }, _temp), _possibleConstructorReturn(_this, _ret);
    }

    _createClass(QuestionnaireGroup, [{
        key: 'componentDidMount',
        value: function componentDidMount() {
            var fields = this.props.fields;


            this.calculatePercentage(fields);
        }
    }, {
        key: 'componentWillReceiveProps',
        value: function componentWillReceiveProps(nextProps) {
            if (!Object.is(nextProps, this.props)) {
                var fields = nextProps.fields;


                this.calculatePercentage(fields);
            }
        }
    }, {
        key: 'render',
        value: function render() {
            var percentage = this.state.percentage;


            var header = this.getHeader();
            var content = this.getContent();

            console.info("This is the current percentage => " + percentage);

            return _react2.default.createElement(
                'section',
                null,
                _react2.default.createElement(
                    'div',
                    { className: 'row' },
                    _react2.default.createElement(
                        'div',
                        { className: 'container-fluid', style: { marginTop: "10px" } },
                        _react2.default.createElement(
                            'h5',
                            null,
                            'The currently progress is ' + percentage + ' %'
                        ),
                        _react2.default.createElement(_materialUi.LinearProgress, { value: percentage, min: 0, max: 100, mode: 'determinate', style: { height: "10px" } })
                    ),
                    _react2.default.createElement(
                        'div',
                        { className: 'metaform-group' },
                        _react2.default.createElement(
                            'div',
                            { className: 'col-md-12', style: { marginTop: "10px" } },
                            header
                        ),
                        _react2.default.createElement(
                            'div',
                            { className: 'metaform-group-content' },
                            content
                        )
                    )
                )
            );
        }
    }]);

    return QuestionnaireGroup;
}(_BaseGroup3.default)) || _class;

QuestionnaireGroup.propTypes = {
    component: _react.PropTypes.string,
    fields: _react.PropTypes.array.isRequired,
    layout: _react.PropTypes.object.isRequired,
    componentFactory: _react.PropTypes.object.isRequired
};

exports.default = QuestionnaireGroup;
module.exports = exports['default'];