'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _class;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _BaseGroup2 = require('./BaseGroup');

var _BaseGroup3 = _interopRequireDefault(_BaseGroup2);

var _materialUi = require('material-ui');

var _Arrays = require('../../util/Arrays');

var _Arrays2 = _interopRequireDefault(_Arrays);

var _wrapUpdate = require('../../util/wrapUpdate');

var _wrapUpdate2 = _interopRequireDefault(_wrapUpdate);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var WizardGroup = (0, _wrapUpdate2.default)(_class = function (_BaseGroup) {
    _inherits(WizardGroup, _BaseGroup);

    function WizardGroup() {
        var _ref;

        var _temp, _this, _ret;

        _classCallCheck(this, WizardGroup);

        for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
            args[_key] = arguments[_key];
        }

        return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = WizardGroup.__proto__ || Object.getPrototypeOf(WizardGroup)).call.apply(_ref, [this].concat(args))), _this), _this.wizardContext = {
            fields: {},
            goToStep: function goToStep(stepName) {
                return _this.toStep(stepName);
            },
            goToPosition: function goToPosition(position) {
                return _this.toPosition(position);
            },
            next: function next() {
                return _this.nextStep();
            }
        }, _this.state = {
            position: 0,
            totalSteps: _this.props.layout.groups.length - 1,
            stepFlow: []
        }, _this.toStep = function (stepName) {
            var steps = _this.getSteps();
            var foundStep = steps.find(function (step) {
                return step.name === stepName;
            });

            if (foundStep) {
                _this.trackStepFlow(foundStep.position);
                _this.setState({ position: foundStep.position });
            } else {
                console.error('Step ' + stepName + ' does not exists');
            }
        }, _this.toPosition = function (position) {
            var totalSteps = _this.state.totalSteps;


            if (position >= 0 && position <= totalSteps) {
                _this.trackStepFlow(position);
                _this.setState({ position: position });
            } else {
                console.error('Position ' + position + ' does not exists');
            }
        }, _this.trackStepFlow = function (position) {
            var stepFlow = _this.state.stepFlow;


            stepFlow.push({
                originalPosition: _this.state.position,
                position: position
            });

            _this.setState({ stepFlow: stepFlow });

            console.log(JSON.stringify(stepFlow));
        }, _this.backToFlow = function () {
            var stepFlow = _this.state.stepFlow;

            var flowOnBack = stepFlow.pop();

            _this.setState({
                stepFlow: stepFlow,
                position: flowOnBack.originalPosition
            });
        }, _this.isFlowInMyPosition = function () {
            var _this$state = _this.state;
            var stepFlow = _this$state.stepFlow;
            var position = _this$state.position;
            var length = stepFlow.length;

            if (length > 0) return stepFlow[length - 1].position == position;

            return false;
        }, _this.nextStep = function () {
            var position = _this.state.position;


            _this.setState({ position: position + 1 });
        }, _this.backStep = function () {
            var position = _this.state.position;


            _this.setState({ position: position - 1 });
        }, _this.updateWizardContext = function () {
            var fields = _this.props.fields;

            // Reads each field value of autoform and creates an object fieldName => fieldValue.

            _this.wizardContext.fields = _Arrays2.default.mergeJson(fields.map(function (field) {
                return _defineProperty({}, field.name, field.reduxFormProps.value);
            }));
        }, _this.getButtonSection = function (steps) {
            var _this$state2 = _this.state;
            var position = _this$state2.position;
            var totalSteps = _this$state2.totalSteps;
            var transition = steps[position].transition;


            var nextButton = null;
            var backButton = null;

            if (position != 0) {
                backButton = _react2.default.createElement(_materialUi.RaisedButton, { label: 'Back', onClick: _this.isFlowInMyPosition() ? _this.backToFlow : _this.backStep, primary: true });
            }

            if (position != totalSteps) {
                nextButton = _react2.default.createElement(_materialUi.RaisedButton, { label: 'Next', onClick: transition ? function () {
                        return transition(_this.wizardContext);
                    } : _this.nextStep, primary: true });
            }

            return _react2.default.createElement(
                'div',
                { className: 'row' },
                _react2.default.createElement(
                    'div',
                    { className: 'col-md-12' },
                    _react2.default.createElement(
                        _materialUi.Toolbar,
                        { style: { backgroundColor: "#ffffff" } },
                        _react2.default.createElement(_materialUi.ToolbarGroup, { firstChild: true }),
                        _react2.default.createElement(
                            _materialUi.ToolbarGroup,
                            { lastChild: true },
                            backButton,
                            nextButton
                        )
                    )
                )
            );
        }, _this.getSteps = function () {
            var layout = _this.props.layout;

            var content = _this.getContent();

            // Maps each content to his transition function
            // Each step has associated a name and a position.
            return layout.groups.map(function (group, index) {
                return {
                    content: content[index],
                    transition: group.transition,
                    name: group.name,
                    position: index
                };
            });
        }, _temp), _possibleConstructorReturn(_this, _ret);
    }

    // Expose functions to the user in order to make the transitions, and the field values of the form


    // Saves an object containing the step position that started the flow and the position after that flow


    // Get the last flow and set the step position to the step that initiated the flow to the current step position.


    // Checks if the current step is the last step in stepFlow, if that's the case it returns true.


    _createClass(WizardGroup, [{
        key: 'render',
        value: function render() {
            var position = this.state.position;

            var steps = this.getSteps();
            var buttonSection = this.getButtonSection(steps);

            this.updateWizardContext();

            return _react2.default.createElement(
                'section',
                null,
                _react2.default.createElement(
                    'div',
                    { className: 'row' },
                    _react2.default.createElement(
                        'div',
                        { className: 'metaform-group' },
                        steps[position].content
                    )
                ),
                buttonSection
            );
        }
    }]);

    return WizardGroup;
}(_BaseGroup3.default)) || _class;

WizardGroup.propTypes = {
    component: _react.PropTypes.string,
    fields: _react.PropTypes.array.isRequired,
    layout: _react.PropTypes.object.isRequired,
    componentFactory: _react.PropTypes.object.isRequired
};

exports.default = WizardGroup;
module.exports = exports['default'];