'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _class;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _BaseGroup2 = require('./BaseGroup');

var _BaseGroup3 = _interopRequireDefault(_BaseGroup2);

var _materialUi = require('material-ui');

var _wrapUpdate = require('../../util/wrapUpdate');

var _wrapUpdate2 = _interopRequireDefault(_wrapUpdate);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var WizardTabGroup = (0, _wrapUpdate2.default)(_class = function (_BaseGroup) {
    _inherits(WizardTabGroup, _BaseGroup);

    function WizardTabGroup() {
        var _ref;

        var _temp, _this, _ret;

        _classCallCheck(this, WizardTabGroup);

        for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
            args[_key] = arguments[_key];
        }

        return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = WizardTabGroup.__proto__ || Object.getPrototypeOf(WizardTabGroup)).call.apply(_ref, [this].concat(args))), _this), _this.state = {
            totalSteps: _this.props.layout.groups.length - 1,
            position: 0
        }, _this.getComponents = function () {
            var _this$props = _this.props;
            var layout = _this$props.layout;
            var componentFactory = _this$props.componentFactory;
            var fields = _this$props.fields;

            var components = void 0;

            if (layout.fields) {

                components = layout.fields.map(function (field) {
                    var fieldMetadata = fields.find(function (cp) {
                        return cp.name === field.name;
                    });

                    if (!fieldMetadata) {
                        throw Error('Could not find field. Field: ' + field.name);
                    }

                    // in case the field is going to render layouts internally, it's going to need information about the
                    // layout and field. I'm not sure if this is the best way to do it, probably not. TODO: Review it.
                    fieldMetadata._extra = { layout: layout, fields: fields };

                    return {
                        data: fieldMetadata,
                        length: layout.fields.length,
                        component: componentFactory.buildFieldComponent(fieldMetadata)
                    };
                });
            } else if (layout.groups) {
                components = layout.groups.map(function (group) {
                    group = _extends({}, group, { headLess: true });

                    return {
                        data: group,
                        length: layout.groups.length,
                        component: componentFactory.buildGroupComponent({
                            component: group.component,
                            layout: group,
                            fields: fields,
                            componentFactory: componentFactory
                        })
                    };
                });
            }

            return components;
        }, _this.nextStep = function () {
            var position = _this.state.position;


            _this.setState({ position: position + 1 });
            _this.onTabSelected(position + 1);
        }, _this.backStep = function () {
            var position = _this.state.position;


            _this.setState({ position: position - 1 });
            _this.onTabSelected(position - 1);
        }, _this.getButtonSection = function () {
            var _this$state = _this.state;
            var position = _this$state.position;
            var totalSteps = _this$state.totalSteps;


            var nextButton = null;
            var backButton = null;

            if (position != 0) {
                backButton = _react2.default.createElement(_materialUi.RaisedButton, { label: 'Back', onClick: _this.backStep, primary: true });
            }

            if (position != totalSteps) {
                nextButton = _react2.default.createElement(_materialUi.RaisedButton, { label: 'Next', onClick: _this.nextStep, primary: true });
            }

            return _react2.default.createElement(
                'div',
                { className: 'row' },
                _react2.default.createElement(
                    'div',
                    { className: 'col-md-12' },
                    _react2.default.createElement(
                        _materialUi.Toolbar,
                        { style: { backgroundColor: "#ffffff" } },
                        _react2.default.createElement(_materialUi.ToolbarGroup, { firstChild: true }),
                        _react2.default.createElement(
                            _materialUi.ToolbarGroup,
                            { lastChild: true },
                            backButton,
                            nextButton
                        )
                    )
                )
            );
        }, _this.onTabSelected = function (position) {
            _this.setState({ position: position });
        }, _temp), _possibleConstructorReturn(_this, _ret);
    }

    _createClass(WizardTabGroup, [{
        key: 'render',
        value: function render() {
            var layout = this.props.layout;
            var position = this.state.position;

            var content = this.getContent();
            var buttonSection = this.getButtonSection();

            return _react2.default.createElement(
                'section',
                null,
                _react2.default.createElement(
                    'div',
                    { className: 'container-fluid' },
                    _react2.default.createElement(
                        'div',
                        { className: 'row' },
                        _react2.default.createElement(
                            'div',
                            { className: 'metaform-group' },
                            _react2.default.createElement(
                                _materialUi.Tabs,
                                { initialSelectedIndex: position, value: position, onChange: this.onTabSelected },
                                layout.groups.map(function (_ref2, index) {
                                    var title = _ref2.title;
                                    return _react2.default.createElement(_materialUi.Tab, { key: index, label: title, value: index });
                                })
                            ),
                            _react2.default.createElement(
                                'div',
                                { className: 'metaform-group-content' },
                                content[position]
                            )
                        ),
                        buttonSection
                    )
                )
            );
        }
    }]);

    return WizardTabGroup;
}(_BaseGroup3.default)) || _class;

WizardTabGroup.propTypes = {
    component: _react.PropTypes.string,
    fields: _react.PropTypes.array.isRequired,
    layout: _react.PropTypes.object.isRequired,
    componentFactory: _react.PropTypes.object.isRequired
};

exports.default = WizardTabGroup;
module.exports = exports['default'];